//---------------------------------------------------
// module  : PRIF.h                         
// auteur  : Max Mignotte                            
// date    :                                              
// langage : C++                                      
// labo    :                                  
//---------------------------------------------------

#ifndef PRIF_H
#define PRIF_H

//------------------------------------------------
// FICHIERS INCLUS -------------------------------
//------------------------------------------------
#include "FunctionPRIF.h"

//------------------------------------------------
// DEFINITIONS -----------------------------------
//------------------------------------------------
#define NB_ESPACE_COUL 60
#define NCHAR 200

//------------------------------------------------
// CLASSE CLUSTERSEG -----------------------------
//------------------------------------------------
class ClusterSeg
{
  //--Donnees--
  //-----------
  public:

  //Matrices Img
  int***    mat_img;
  float***  smat_seg;
  float**   mat_seg; 
  
  //Windows
  int** win_tabseg;
  int SizeS;

  //ParamIMG
  int width,length;

  //Parametre.
  int   NbCl0,NbCl1,NbCl2,NbCl3,NbCl4,NbCl5,NbCl6;
  float DistBhatta;
  int   NbSegs;

  int   Seed;
  int   Size1,Size2;
  int   NbBins;
  int   NbClassMin;
  int   SizeMin;

  //ParametreSeg
  int   NbRegions;
 
  //Flag
  int  flag_save;
  int  flag_visu;

  //Utile
  char Name_Sauve[NCHAR];
  char Name_Img[NCHAR];
  char Extension[NCHAR];  

  //--Methodes--
  //------------
  public:
  ClusterSeg(int***,int,int);
  ~ClusterSeg();

  //Function
  void ComputeWindows(int,int,int); 
  void Segmente();
 
  //-------------------------------------------------
  //Algorithm
  //-------------------------------------------------
  //Segmentation <Histo><COLOR-BASE>
  void  SegmentationHistoCOLORKmeanFast(int***,float**,int,int,int,int,int,int,int); 

  //FuseRegions
  float ComputeNrjLocReg(float**,float**,int,int,float***,int,float*);
  float ComputeNrj(float**,float***,int,float*);
  int FuseRegionsPrior(float**,float***,int,int,float,int*,int);
};

#endif 
